# Detector

Detector for anomalous event

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | [**DetectorType**](DetectorType.md) |  | [optional] 
**enabled** | **bool** | Describes whether the detector is currently enabled. | [optional] 
**settings** | [**BaseAnomalySettingList**](BaseAnomalySettingList.md) |  | [optional] 
**exclusion_settings** | [**ExclusionSetting**](ExclusionSetting.md) |  | [optional] 
**tactics** | [**List[Tactic]**](Tactic.md) | MITRE ATT&amp;CK tactic(s) supported by the detector | [optional] 
**techniques** | [**List[Technique]**](Technique.md) | MITRE ATT&amp;CK technique(s) supported by the detector | [optional] 
**sites** | **List[str]** | List of site UUIDs the detector is installed on. | [optional] 

## Example

```python
from openapi.models.detector import Detector

# TODO update the JSON string below
json = "{}"
# create an instance of Detector from a JSON string
detector_instance = Detector.from_json(json)
# print the JSON string representation of the object
print Detector.to_json()

# convert the object into a dict
detector_dict = detector_instance.to_dict()
# create an instance of Detector from a dict
detector_form_dict = detector.from_dict(detector_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


