# EndPoint

Represents endpoint where data will be gathered

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**var_self** | [**SelfResourceLink**](SelfResourceLink.md) |  | [optional] 
**links** | [**List[ResourceLink]**](ResourceLink.md) | The server will populate this field when returing the resource. Ignored on PUT and POST. | [optional] 
**var_schema** | **str** | Schema for this resource | [optional] 
**revision** | **int** | The _revision property describes the current revision of the resource. To prevent clients from overwriting each other&#39;s changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected. | [optional] 
**resource_type** | **str** | The type of this resource. | [optional] 
**create_user** | **str** | ID of the user who created this resource | [optional] 
**create_time** | **int** | Timestamp in milliseconds since epoch | [optional] 
**last_modified_user** | **str** | ID of the user who last modified this resource | [optional] 
**last_modified_time** | **int** | Timestamp in milliseconds since epoch | [optional] 
**system_owned** | **bool** | Indicates system owned resource | [optional] 
**protection** | **str** | Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite&#x3D;true. UNKNOWN - the _protection field could not be determined for this           entity.  | [optional] 
**id** | **str** | Unique identifier of this resource | [optional] 
**display_name** | **str** | Defaults to ID if not set | [optional] 
**description** | **str** | Description of this resource | [optional] 
**path** | **str** | Absolute path of this object | [optional] 
**relative_path** | **str** | Path relative from its parent | [optional] 
**parent_path** | **str** | Path of its parent | [optional] 
**end_point_address** | **str** | Value of this property could be hostname or ip. eg. For NSX-T manager running on default port the value can be \&quot;10.192.1.1\&quot;, for NSX-T manager running on custom port value can be \&quot;192.168.1.1:32789\&quot;.  | 
**username** | **str** | User name to connect to MP | [optional] 
**password** | **str** | Password to connect to MP | [optional] 
**token** | **str** | One time authentication token to connect to MP | [optional] 
**protocol** | **str** | Protocol like http or https  | [optional] 
**thumbprint** | **str** | Thumbprint of EndPoint. sha-256 hash represented in lower case hex.  | [optional] 

## Example

```python
from openapi.models.end_point import EndPoint

# TODO update the JSON string below
json = "{}"
# create an instance of EndPoint from a JSON string
end_point_instance = EndPoint.from_json(json)
# print the JSON string representation of the object
print EndPoint.to_json()

# convert the object into a dict
end_point_dict = end_point_instance.to_dict()
# create an instance of EndPoint from a dict
end_point_form_dict = end_point.from_dict(end_point_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


