# NormalizedRecommendationRule

The detailed information of a normalized rule

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**src_vm_ids** | **List[str]** | all vm/bm ids from the src groups if exists | [optional] 
**dst_vm_ids** | **List[str]** | all vm/bm ids from the dst groups if exists | [optional] 
**src_ips** | **List[str]** | all Ips/CIDRs from the src groups if exists | [optional] 
**dst_ips** | **List[str]** | all Ips/CIDRs from the dst groups if exists | [optional] 
**context_src_vm_ids** | **List[str]** | the overlap vm/bm ids between the src groups and applied-to groups if exists | [optional] 
**context_dst_vm_ids** | **List[str]** | the overlap vm/bm ids between the dst groups and applied-to groups if exists | [optional] 
**context_src_ips** | **List[str]** | the overlap Ips/CIDRs between the src groups and applied-to groups if exists | [optional] 
**context_dst_ips** | **List[str]** | the overlap Ips/CIDRs between the dst groups and applied-to groups if exists | [optional] 
**dst_ports** | **List[str]** | The destination port(s) of the selected rule | [optional] 
**protocols** | **List[str]** | The protocol(s) of the selected rule | [optional] 
**app_ids** | **List[str]** | The appId(s) of the selected rule | [optional] 

## Example

```python
from openapi.models.normalized_recommendation_rule import NormalizedRecommendationRule

# TODO update the JSON string below
json = "{}"
# create an instance of NormalizedRecommendationRule from a JSON string
normalized_recommendation_rule_instance = NormalizedRecommendationRule.from_json(json)
# print the JSON string representation of the object
print NormalizedRecommendationRule.to_json()

# convert the object into a dict
normalized_recommendation_rule_dict = normalized_recommendation_rule_instance.to_dict()
# create an instance of NormalizedRecommendationRule from a dict
normalized_recommendation_rule_form_dict = normalized_recommendation_rule.from_dict(normalized_recommendation_rule_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


