# RbacPermission

RBAC permission of individual intelligence API

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**feature** | **str** | Feature name shared by a group of APIs  | [optional] 
**operation_id** | **str** | A unique name to identify an API method  | [optional] 
**path** | **str** | API path  | [optional] 
**http_method** | **str** | HTTP method allowed by this API  | [optional] 
**authorizations** | **List[str]** | A list of authorized roles of this API  | [optional] 

## Example

```python
from openapi.models.rbac_permission import RbacPermission

# TODO update the JSON string below
json = "{}"
# create an instance of RbacPermission from a JSON string
rbac_permission_instance = RbacPermission.from_json(json)
# print the JSON string representation of the object
print RbacPermission.to_json()

# convert the object into a dict
rbac_permission_dict = rbac_permission_instance.to_dict()
# create an instance of RbacPermission from a dict
rbac_permission_form_dict = rbac_permission.from_dict(rbac_permission_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


