# RemoteServiceEdge

Describes the connection between two nodes(VM, BareMetal, etc..).

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **str** | ID of this edge. | [optional] 
**l7_app_name** | **str** | L7 app name for this connection. | [optional] 
**port** | **str** | Destination port number used for this connection. | [optional] 
**protocol** | **str** | Protocol used for this connection. | [optional] 
**user** | **str** | User id for this connection. | [optional] 
**is_suspicious** | **bool** | Indicates whether this connection is usual or suspicious. | [optional] 
**start_time** | **int** | Time when the flow is started. | [optional] 
**end_time** | **int** | Time when the flow is ended. | [optional] 
**from_node** | **str** | ID of the &#39;from&#39; node where the connection started. | [optional] 
**to_node** | **str** | ID of the &#39;to&#39; node where the connection ended. | [optional] 

## Example

```python
from openapi.models.remote_service_edge import RemoteServiceEdge

# TODO update the JSON string below
json = "{}"
# create an instance of RemoteServiceEdge from a JSON string
remote_service_edge_instance = RemoteServiceEdge.from_json(json)
# print the JSON string representation of the object
print RemoteServiceEdge.to_json()

# convert the object into a dict
remote_service_edge_dict = remote_service_edge_instance.to_dict()
# create an instance of RemoteServiceEdge from a dict
remote_service_edge_form_dict = remote_service_edge.from_dict(remote_service_edge_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


