# RequestParameters

The set of parameters for returning a list of records.

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**filter_elements** | [**List[FilterElement]**](FilterElement.md) | A list of filter elements. | [optional] 
**cursor** | **str** | A cursor to keep track of pages returned by the backend (a page number) | [optional] 
**page_size** | **int** | Number of records to be returned in the API request | [optional] [default to 100]
**sort_ascending** | **bool** | True, if the list of records returned need to be sorted in ascending order, false otherwise. | [optional] [default to False]
**sort_by** | [**SortBy**](SortBy.md) |  | [optional] 

## Example

```python
from openapi.models.request_parameters import RequestParameters

# TODO update the JSON string below
json = "{}"
# create an instance of RequestParameters from a JSON string
request_parameters_instance = RequestParameters.from_json(json)
# print the JSON string representation of the object
print RequestParameters.to_json()

# convert the object into a dict
request_parameters_dict = request_parameters_instance.to_dict()
# create an instance of RequestParameters from a dict
request_parameters_form_dict = request_parameters.from_dict(request_parameters_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


