# TimeIntervalListSiteConnectionRequest

Request about connection between two sites, returning a list of records based on a specified time range.

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**time_interval** | [**TimeInterval**](TimeInterval.md) |  | 
**filters** | [**List[BaseFilter]**](BaseFilter.md) | A list of filters | [optional] 
**filter_elements** | [**List[FilterElement]**](FilterElement.md) | A list of filter elements. | [optional] 
**cursor** | **str** | A cursor to keep track of pages returned by the backend (a page number) | [optional] 
**page_size** | **int** | Number of records to be returned in the API request | [optional] [default to 100]
**sort_ascending** | **bool** | True, if the list of records returned need to be sorted in ascending order, false otherwise. | [optional] [default to False]
**sort_by** | [**SortBy**](SortBy.md) |  | [optional] 
**src_site_id** | **str** | The id of site which is source of connection. | [default to 'default']
**dst_site_id** | **str** | The id of site which is destination of connection. | [default to 'default']

## Example

```python
from openapi.models.time_interval_list_site_connection_request import TimeIntervalListSiteConnectionRequest

# TODO update the JSON string below
json = "{}"
# create an instance of TimeIntervalListSiteConnectionRequest from a JSON string
time_interval_list_site_connection_request_instance = TimeIntervalListSiteConnectionRequest.from_json(json)
# print the JSON string representation of the object
print TimeIntervalListSiteConnectionRequest.to_json()

# convert the object into a dict
time_interval_list_site_connection_request_dict = time_interval_list_site_connection_request_instance.to_dict()
# create an instance of TimeIntervalListSiteConnectionRequest from a dict
time_interval_list_site_connection_request_form_dict = time_interval_list_site_connection_request.from_dict(time_interval_list_site_connection_request_dict)
```
[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


