# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator
from openapi.models.anomaly_events_request import AnomalyEventsRequest

class AnomalyEntityFilterRequest(BaseModel):
    """
    Request model to retrieve association between entity and anomaly events  # noqa: E501
    """
    event_filter: Optional[AnomalyEventsRequest] = None
    group_by: Optional[StrictStr] = Field(None, description="Group by entity type")
    __properties = ["event_filter", "group_by"]

    @validator('group_by')
    def group_by_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('COMPUTE', 'VM', 'GROUP'):
            raise ValueError("must be one of enum values ('COMPUTE', 'VM', 'GROUP')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AnomalyEntityFilterRequest:
        """Create an instance of AnomalyEntityFilterRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of event_filter
        if self.event_filter:
            _dict['event_filter'] = self.event_filter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AnomalyEntityFilterRequest:
        """Create an instance of AnomalyEntityFilterRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AnomalyEntityFilterRequest.parse_obj(obj)

        _obj = AnomalyEntityFilterRequest.parse_obj({
            "event_filter": AnomalyEventsRequest.from_dict(obj.get("event_filter")) if obj.get("event_filter") is not None else None,
            "group_by": obj.get("group_by")
        })
        return _obj


