# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conint, conlist
from openapi.models.anomaly_event_affected_object import AnomalyEventAffectedObject
from openapi.models.detector_type import DetectorType
from openapi.models.tactic import Tactic
from openapi.models.technique import Technique

class AnomalyEvent(BaseModel):
    """
    An anomaly event  # noqa: E501
    """
    id: Optional[StrictStr] = Field(None, description="uuid of the event")
    tactic: Optional[Tactic] = None
    technique: Optional[Technique] = None
    detector_name: Optional[DetectorType] = None
    description: Optional[StrictStr] = Field(None, description="Description of the event")
    confidence: Optional[conint(strict=True, le=100, ge=1)] = Field(None, description="confidence of the detector for this event (range 0-100)")
    severity: Optional[conint(strict=True, le=100, ge=1)] = Field(None, description="Severity of the event (range 0-100)")
    impact: Optional[conint(strict=True, le=100, ge=0)] = Field(None, description="impact score for this event (function of confidence & severity)")
    event_time: Optional[StrictInt] = Field(None, description="Event time")
    affected_objects: Optional[conlist(AnomalyEventAffectedObject)] = Field(None, description="List of objects affected by the anomaly event.")
    __properties = ["id", "tactic", "technique", "detector_name", "description", "confidence", "severity", "impact", "event_time", "affected_objects"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> AnomalyEvent:
        """Create an instance of AnomalyEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in affected_objects (list)
        _items = []
        if self.affected_objects:
            for _item in self.affected_objects:
                if _item:
                    _items.append(_item.to_dict())
            _dict['affected_objects'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AnomalyEvent:
        """Create an instance of AnomalyEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return AnomalyEvent.parse_obj(obj)

        _obj = AnomalyEvent.parse_obj({
            "id": obj.get("id"),
            "tactic": obj.get("tactic"),
            "technique": obj.get("technique"),
            "detector_name": obj.get("detector_name"),
            "description": obj.get("description"),
            "confidence": obj.get("confidence"),
            "severity": obj.get("severity"),
            "impact": obj.get("impact"),
            "event_time": obj.get("event_time"),
            "affected_objects": [AnomalyEventAffectedObject.from_dict(_item) for _item in obj.get("affected_objects")] if obj.get("affected_objects") is not None else None
        })
        return _obj


