# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictStr, conlist, validator
from openapi.models.filter_element import FilterElement

class BaseAnomalyEventDetail(BaseModel):
    """
    Base model for anomaly event detail  # noqa: E501
    """
    report_type: Optional[StrictStr] = Field(None, description="Type of report")
    viz_filter_elements: Optional[conlist(FilterElement)] = Field(None, description="A list of filter elements to view anomaly related flows in the VIZ main screen")
    __properties = ["report_type", "viz_filter_elements"]

    @validator('report_type')
    def report_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TRAFFIC_DROP', 'HORIZONTAL_PORT_SCAN', 'VERTICAL_PORT_SCAN', 'UNCOMMONLY_USED_PORT', 'LLMNR_NBTNS', 'REMOTE_SERVICES', 'FLOW_BEACONING', 'DEST_IP_PROFILER', 'SERVER_PORT_PROFILER', 'PORT_PROFILER', 'UPDOWNLOADER_TIMESERIES', 'DNS_TUNNELING', 'DGA', 'DATA_UPDOWNLOADER'):
            raise ValueError("must be one of enum values ('TRAFFIC_DROP', 'HORIZONTAL_PORT_SCAN', 'VERTICAL_PORT_SCAN', 'UNCOMMONLY_USED_PORT', 'LLMNR_NBTNS', 'REMOTE_SERVICES', 'FLOW_BEACONING', 'DEST_IP_PROFILER', 'SERVER_PORT_PROFILER', 'PORT_PROFILER', 'UPDOWNLOADER_TIMESERIES', 'DNS_TUNNELING', 'DGA', 'DATA_UPDOWNLOADER')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    # JSON field name that stores the object type
    __discriminator_property_name = 'report_type'

    # discriminator mappings
    __discriminator_value_class_map = {
        'DataUpDownLoaderEventDetail': 'DataUpDownLoaderEventDetail',
        'DestIpProfilerEventDetail': 'DestIpProfilerEventDetail',
        'DgaEventDetail': 'DgaEventDetail',
        'DnsTunnelingEventDetail': 'DnsTunnelingEventDetail',
        'FlowBeaconingEventDetail': 'FlowBeaconingEventDetail',
        'NameResolutionReport': 'NameResolutionReport',
        'NonStandardPortUsageEventDetail': 'NonStandardPortUsageEventDetail',
        'PortProfilerEventDetail': 'PortProfilerEventDetail',
        'PortScanVerticalEventDetail': 'PortScanVerticalEventDetail',
        'PortSweepEventDetails': 'PortSweepEventDetails',
        'RemoteServicesEventDetail': 'RemoteServicesEventDetail',
        'ServerPortProfilerEventDetail': 'ServerPortProfilerEventDetail',
        'TrafficDropEventDetail': 'TrafficDropEventDetail',
        'UpDownLoaderTimeSeriesEventDetail': 'UpDownLoaderTimeSeriesEventDetail'
    }

    @classmethod
    def get_discriminator_value(cls, obj: dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union(DataUpDownLoaderEventDetail, DestIpProfilerEventDetail, DgaEventDetail, DnsTunnelingEventDetail, FlowBeaconingEventDetail, NameResolutionReport, NonStandardPortUsageEventDetail, PortProfilerEventDetail, PortScanVerticalEventDetail, PortSweepEventDetails, RemoteServicesEventDetail, ServerPortProfilerEventDetail, TrafficDropEventDetail, UpDownLoaderTimeSeriesEventDetail):
        """Create an instance of BaseAnomalyEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Union(DataUpDownLoaderEventDetail, DestIpProfilerEventDetail, DgaEventDetail, DnsTunnelingEventDetail, FlowBeaconingEventDetail, NameResolutionReport, NonStandardPortUsageEventDetail, PortProfilerEventDetail, PortScanVerticalEventDetail, PortSweepEventDetails, RemoteServicesEventDetail, ServerPortProfilerEventDetail, TrafficDropEventDetail, UpDownLoaderTimeSeriesEventDetail):
        """Create an instance of BaseAnomalyEventDetail from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("BaseAnomalyEventDetail failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from openapi.models.data_up_down_loader_event_detail import DataUpDownLoaderEventDetail
from openapi.models.dest_ip_profiler_event_detail import DestIpProfilerEventDetail
from openapi.models.dga_event_detail import DgaEventDetail
from openapi.models.dns_tunneling_event_detail import DnsTunnelingEventDetail
from openapi.models.flow_beaconing_event_detail import FlowBeaconingEventDetail
from openapi.models.name_resolution_report import NameResolutionReport
from openapi.models.non_standard_port_usage_event_detail import NonStandardPortUsageEventDetail
from openapi.models.port_profiler_event_detail import PortProfilerEventDetail
from openapi.models.port_scan_vertical_event_detail import PortScanVerticalEventDetail
from openapi.models.port_sweep_event_details import PortSweepEventDetails
from openapi.models.remote_services_event_detail import RemoteServicesEventDetail
from openapi.models.server_port_profiler_event_detail import ServerPortProfilerEventDetail
from openapi.models.traffic_drop_event_detail import TrafficDropEventDetail
from openapi.models.up_down_loader_time_series_event_detail import UpDownLoaderTimeSeriesEventDetail
BaseAnomalyEventDetail.update_forward_refs()

