# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator

class BaseFilter(BaseModel):
    """
    Base key-value object for filter. Will be deprecated. Please use FilterElement  # noqa: E501
    """
    key: StrictStr = Field(..., description="The key is a string.")
    value: StrictStr = Field(..., description="The values is in the format of a comma-separated string.")
    criteria: Optional[StrictStr] = Field(None, description="criteria for controlling how the value is matched.")
    __properties = ["key", "value", "criteria"]

    @validator('criteria')
    def criteria_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('EQUALS', 'CONTAINS', 'STARTS_WITH'):
            raise ValueError("must be one of enum values ('EQUALS', 'CONTAINS', 'STARTS_WITH')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BaseFilter:
        """Create an instance of BaseFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BaseFilter:
        """Create an instance of BaseFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BaseFilter.parse_obj(obj)

        _obj = BaseFilter.parse_obj({
            "key": obj.get("key"),
            "value": obj.get("value"),
            "criteria": obj.get("criteria")
        })
        return _obj


