# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt

class BeaconingFeatures(BaseModel):
    """
    The features used to cluster flows in the beaconing detector.  # noqa: E501
    """
    iat: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The inter-arrival time with the previous flow.")
    bytes: Optional[StrictInt] = Field(None, description="The number of bytes sent in the flow.")
    ts: Optional[StrictInt] = Field(None, description="The timestamp of a flow (as msec from the epoch).")
    __properties = ["iat", "bytes", "ts"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BeaconingFeatures:
        """Create an instance of BeaconingFeatures from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BeaconingFeatures:
        """Create an instance of BeaconingFeatures from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BeaconingFeatures.parse_obj(obj)

        _obj = BeaconingFeatures.parse_obj({
            "iat": obj.get("iat"),
            "bytes": obj.get("bytes"),
            "ts": obj.get("ts")
        })
        return _obj


