# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import Field, StrictStr, conlist, validator
from openapi.models.filter_element import FilterElement

class ConditionalFilter(FilterElement):
    """
    Conditional filter object which is | composed of an array of SimpleFilter. Condition is AND/OR/NOT for now.  # noqa: E501
    """
    filters: conlist(FilterElement) = Field(..., description="A list of simple filters")
    condition: StrictStr = Field(..., description="criteria for controlling how the value is matched.")
    __properties = ["filter_type", "filters", "condition"]

    @validator('condition')
    def condition_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('OR', 'AND', 'NOT'):
            raise ValueError("must be one of enum values ('OR', 'AND', 'NOT')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ConditionalFilter:
        """Create an instance of ConditionalFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in filters (list)
        _items = []
        if self.filters:
            for _item in self.filters:
                if _item:
                    _items.append(_item.to_dict())
            _dict['filters'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ConditionalFilter:
        """Create an instance of ConditionalFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ConditionalFilter.parse_obj(obj)

        _obj = ConditionalFilter.parse_obj({
            "filter_type": obj.get("filter_type") if obj.get("filter_type") is not None else 'SIMPLE',
            "filters": [FilterElement.from_dict(_item) for _item in obj.get("filters")] if obj.get("filters") is not None else None,
            "condition": obj.get("condition")
        })
        return _obj


