# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from openapi.models.base_anomaly_setting_list import BaseAnomalySettingList
from openapi.models.detector_type import DetectorType
from openapi.models.exclusion_setting import ExclusionSetting
from openapi.models.tactic import Tactic
from openapi.models.technique import Technique

class Detector(BaseModel):
    """
    Detector for anomalous event  # noqa: E501
    """
    name: Optional[DetectorType] = None
    enabled: Optional[StrictBool] = Field(None, description="Describes whether the detector is currently enabled.")
    settings: Optional[BaseAnomalySettingList] = None
    exclusion_settings: Optional[ExclusionSetting] = None
    tactics: Optional[conlist(Tactic)] = Field(None, description="MITRE ATT&CK tactic(s) supported by the detector")
    techniques: Optional[conlist(Technique)] = Field(None, description="MITRE ATT&CK technique(s) supported by the detector")
    sites: Optional[conlist(StrictStr)] = Field(None, description="List of site UUIDs the detector is installed on.")
    __properties = ["name", "enabled", "settings", "exclusion_settings", "tactics", "techniques", "sites"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Detector:
        """Create an instance of Detector from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of settings
        if self.settings:
            _dict['settings'] = self.settings.to_dict()
        # override the default output from pydantic by calling `to_dict()` of exclusion_settings
        if self.exclusion_settings:
            _dict['exclusion_settings'] = self.exclusion_settings.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Detector:
        """Create an instance of Detector from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Detector.parse_obj(obj)

        _obj = Detector.parse_obj({
            "name": obj.get("name"),
            "enabled": obj.get("enabled"),
            "settings": BaseAnomalySettingList.from_dict(obj.get("settings")) if obj.get("settings") is not None else None,
            "exclusion_settings": ExclusionSetting.from_dict(obj.get("exclusion_settings")) if obj.get("exclusion_settings") is not None else None,
            "tactics": obj.get("tactics"),
            "techniques": obj.get("techniques"),
            "sites": obj.get("sites")
        })
        return _obj


