# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr
from openapi.models.detector_status_label import DetectorStatusLabel
from openapi.models.detector_type import DetectorType

class DetectorStatus(BaseModel):
    """
    Detector run status  # noqa: E501
    """
    name: Optional[DetectorType] = None
    enabled: Optional[StrictBool] = Field(None, description="Describes whether the detector is currently enabled.")
    site_id: Optional[StrictStr] = Field(None, description="site on which detector last ran")
    status: Optional[DetectorStatusLabel] = None
    last_successful_run_time: Optional[StrictInt] = Field(None, description="Last timestamp when the detector successfully finished running")
    remaining_baseline_duration_days: Optional[StrictInt] = Field(None, description="Number of baseline days remaining before detection begins")
    __properties = ["name", "enabled", "site_id", "status", "last_successful_run_time", "remaining_baseline_duration_days"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DetectorStatus:
        """Create an instance of DetectorStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DetectorStatus:
        """Create an instance of DetectorStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DetectorStatus.parse_obj(obj)

        _obj = DetectorStatus.parse_obj({
            "name": obj.get("name"),
            "enabled": obj.get("enabled"),
            "site_id": obj.get("site_id"),
            "status": obj.get("status"),
            "last_successful_run_time": obj.get("last_successful_run_time"),
            "remaining_baseline_duration_days": obj.get("remaining_baseline_duration_days")
        })
        return _obj


