# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, conlist
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement
from openapi.models.scored_items import ScoredItems

class DgaEventDetail(BaseAnomalyEventDetail):
    """
    DgaEventDetail
    """
    domains: Optional[conlist(ScoredItems)] = Field(None, description="The base domain names used in the tunneling activity. A list of domain/score pair(s) specifying the domain name involved in the DGA activity & a confidence score (from 0 to 100) that the requests to that domain were actually part of DGA activity (currently, can only have the value 1)")
    __properties = ["report_type", "viz_filter_elements", "domains"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DgaEventDetail:
        """Create an instance of DgaEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in domains (list)
        _items = []
        if self.domains:
            for _item in self.domains:
                if _item:
                    _items.append(_item.to_dict())
            _dict['domains'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DgaEventDetail:
        """Create an instance of DgaEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DgaEventDetail.parse_obj(obj)

        _obj = DgaEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "domains": [ScoredItems.from_dict(_item) for _item in obj.get("domains")] if obj.get("domains") is not None else None
        })
        return _obj


