# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr, validator
from openapi.models.excluded_items import ExcludedItems
from openapi.models.exclusion_type import ExclusionType

class Exclusion(BaseModel):
    """
    Defines entities which must be exluded from a particular detection logic  # noqa: E501
    """
    id: Optional[StrictStr] = Field(None, description="ID associated with this exclusion object.")
    name: Optional[StrictStr] = Field(None, description="A label associated with this exclusion object")
    exclusion_type: Optional[ExclusionType] = None
    excluded_items: Optional[ExcludedItems] = None
    site: Optional[StrictStr] = Field(None, description="UUID associated with site the exclusion belongs to")
    __properties = ["id", "name", "exclusion_type", "excluded_items", "site"]

    @validator('name')
    def name_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('SOURCE', 'DESTINATION', 'NONE', 'RESPONDER'):
            raise ValueError("must be one of enum values ('SOURCE', 'DESTINATION', 'NONE', 'RESPONDER')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Exclusion:
        """Create an instance of Exclusion from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of excluded_items
        if self.excluded_items:
            _dict['excluded_items'] = self.excluded_items.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Exclusion:
        """Create an instance of Exclusion from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Exclusion.parse_obj(obj)

        _obj = Exclusion.parse_obj({
            "id": obj.get("id"),
            "name": obj.get("name"),
            "exclusion_type": obj.get("exclusion_type"),
            "excluded_items": ExcludedItems.from_dict(obj.get("excluded_items")) if obj.get("excluded_items") is not None else None,
            "site": obj.get("site")
        })
        return _obj


