# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Union
from pydantic import BaseModel, Field, StrictStr, validator

class FilterElement(BaseModel):
    """
    Interface object to represent different filter types.  # noqa: E501
    """
    filter_type: StrictStr = Field(..., description="filter type enum. | SIMPLE maps to BaseFilter CONDITIONAL maps to ConditionalFilter")
    __properties = ["filter_type"]

    @validator('filter_type')
    def filter_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in ('SIMPLE', 'CONDITIONAL'):
            raise ValueError("must be one of enum values ('SIMPLE', 'CONDITIONAL')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    # JSON field name that stores the object type
    __discriminator_property_name = 'filter_type'

    # discriminator mappings
    __discriminator_value_class_map = {
        'ConditionalFilter': 'ConditionalFilter',
        'SimpleFilter': 'SimpleFilter'
    }

    @classmethod
    def get_discriminator_value(cls, obj: dict) -> str:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Union(ConditionalFilter, SimpleFilter):
        """Create an instance of FilterElement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Union(ConditionalFilter, SimpleFilter):
        """Create an instance of FilterElement from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type:
            klass = globals()[object_type]
            return klass.from_dict(obj)
        else:
            raise ValueError("FilterElement failed to lookup discriminator value from " +
                             json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                             ", mapping: " + json.dumps(cls.__discriminator_value_class_map))

from openapi.models.conditional_filter import ConditionalFilter
from openapi.models.simple_filter import SimpleFilter
FilterElement.update_forward_refs()

