# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import Field, StrictFloat, StrictInt, conlist
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.beaconing_features import BeaconingFeatures
from openapi.models.filter_element import FilterElement

class FlowBeaconingEventDetail(BaseAnomalyEventDetail):
    """
    FlowBeaconingEventDetail
    """
    avg_interval: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The average inter-arrival time of flows considered part of the beaconing activity.")
    std_interval: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The standard deviation of inter-arrival times of flows considered part of the beaconing activity.")
    avg_bytes: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The average number of bytes sent in flows considered part of the beaconing activity.")
    std_bytes: Optional[Union[StrictFloat, StrictInt]] = Field(None, description="The standard deviation of the number of bytes sent in flows considered part of the beaconing activity.")
    cluster_size: Optional[StrictInt] = Field(None, description="The number of flows considered part of the beaconing activity.")
    items: Optional[conlist(BeaconingFeatures)] = Field(None, description="The features of flows considered part of the beaconing activity.")
    __properties = ["report_type", "viz_filter_elements", "avg_interval", "std_interval", "avg_bytes", "std_bytes", "cluster_size", "items"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FlowBeaconingEventDetail:
        """Create an instance of FlowBeaconingEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item in self.items:
                if _item:
                    _items.append(_item.to_dict())
            _dict['items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FlowBeaconingEventDetail:
        """Create an instance of FlowBeaconingEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FlowBeaconingEventDetail.parse_obj(obj)

        _obj = FlowBeaconingEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "avg_interval": obj.get("avg_interval"),
            "std_interval": obj.get("std_interval"),
            "avg_bytes": obj.get("avg_bytes"),
            "std_bytes": obj.get("std_bytes"),
            "cluster_size": obj.get("cluster_size"),
            "items": [BeaconingFeatures.from_dict(_item) for _item in obj.get("items")] if obj.get("items") is not None else None
        })
        return _obj


