# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist

class IntelligenceFeature(BaseModel):
    """
    NSX Intelligence available feature and its availability based the form factor and license.   # noqa: E501
    """
    feature: Optional[StrictStr] = Field(None, description="String for the feature name ")
    is_available: Optional[StrictBool] = Field(None, description="Indicated whether the feature is available on the current NSX-Intelligence cluster nodes. ")
    reasons: Optional[conlist(StrictStr)] = Field(None, description="The reason why not available on the NSX-Intelligence cluster nodes ")
    __properties = ["feature", "is_available", "reasons"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IntelligenceFeature:
        """Create an instance of IntelligenceFeature from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IntelligenceFeature:
        """Create an instance of IntelligenceFeature from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IntelligenceFeature.parse_obj(obj)

        _obj = IntelligenceFeature.parse_obj({
            "feature": obj.get("feature"),
            "is_available": obj.get("is_available"),
            "reasons": obj.get("reasons")
        })
        return _obj


