# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist
from openapi.models.intelligence_feature import IntelligenceFeature
from openapi.models.intelligence_operation import IntelligenceOperation
from openapi.models.intelligence_properties import IntelligenceProperties

class IntelligenceFeaturesAndOperationsInfo(BaseModel):
    """
    NSX Intelligence available features and operations. And the permission based on the form factor, license and user's roles.   # noqa: E501
    """
    properties: Optional[IntelligenceProperties] = None
    features: Optional[conlist(IntelligenceFeature)] = Field(None, description="A list of available features in appliance and it indicates if each feature is available on the current appliance. ")
    operations: Optional[conlist(IntelligenceOperation)] = Field(None, description="A list of available operations in appliance and it indicates if each operation ")
    __properties = ["properties", "features", "operations"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> IntelligenceFeaturesAndOperationsInfo:
        """Create an instance of IntelligenceFeaturesAndOperationsInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of properties
        if self.properties:
            _dict['properties'] = self.properties.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in features (list)
        _items = []
        if self.features:
            for _item in self.features:
                if _item:
                    _items.append(_item.to_dict())
            _dict['features'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in operations (list)
        _items = []
        if self.operations:
            for _item in self.operations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['operations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> IntelligenceFeaturesAndOperationsInfo:
        """Create an instance of IntelligenceFeaturesAndOperationsInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return IntelligenceFeaturesAndOperationsInfo.parse_obj(obj)

        _obj = IntelligenceFeaturesAndOperationsInfo.parse_obj({
            "properties": IntelligenceProperties.from_dict(obj.get("properties")) if obj.get("properties") is not None else None,
            "features": [IntelligenceFeature.from_dict(_item) for _item in obj.get("features")] if obj.get("features") is not None else None,
            "operations": [IntelligenceOperation.from_dict(_item) for _item in obj.get("operations")] if obj.get("operations") is not None else None
        })
        return _obj


