# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conint

class ListRequestParameters(BaseModel):
    """
    ListRequestParameters
    """
    included_fields: Optional[StrictStr] = Field(None, description="Comma separated list of fields that should be included in query result")
    sort_by: Optional[StrictStr] = Field(None, description="Field by which records are sorted")
    sort_ascending: Optional[StrictBool] = Field(None, description="Whether to sort in ascending order or not")
    cursor: Optional[StrictStr] = Field(None, description="Opaque cursor to be used for getting next page of records (supplied by current result page)")
    page_size: Optional[conint(strict=True, le=1000, ge=0)] = Field(None, description="Maximum number of results to return in this page (server may return fewer)")
    __properties = ["included_fields", "sort_by", "sort_ascending", "cursor", "page_size"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListRequestParameters:
        """Create an instance of ListRequestParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListRequestParameters:
        """Create an instance of ListRequestParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListRequestParameters.parse_obj(obj)

        _obj = ListRequestParameters.parse_obj({
            "included_fields": obj.get("included_fields"),
            "sort_by": obj.get("sort_by"),
            "sort_ascending": obj.get("sort_ascending"),
            "cursor": obj.get("cursor"),
            "page_size": obj.get("page_size")
        })
        return _obj


