# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from openapi.models.resource_link import ResourceLink
from openapi.models.self_resource_link import SelfResourceLink

class ListResult(BaseModel):
    """
    ListResult
    """
    var_self: Optional[SelfResourceLink] = Field(None, alias="_self")
    links: Optional[conlist(ResourceLink)] = Field(None, alias="_links", description="The server will populate this field when returing the resource. Ignored on PUT and POST.")
    var_schema: Optional[StrictStr] = Field(None, alias="_schema", description="Schema for this resource")
    result_count: Optional[StrictInt] = Field(None, description="Count of results found (across all pages), set only on first page")
    sort_by: Optional[StrictStr] = Field(None, description="Field by which records are sorted")
    sort_ascending: Optional[StrictBool] = Field(None, description="If true, results are sorted in ascending order")
    cursor: Optional[StrictStr] = Field(None, description="Opaque cursor to be used for getting next page of records (supplied by current result page)")
    __properties = ["_self", "_links", "_schema", "result_count", "sort_by", "sort_ascending", "cursor"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ListResult:
        """Create an instance of ListResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of var_self
        if self.var_self:
            _dict['_self'] = self.var_self.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item in self.links:
                if _item:
                    _items.append(_item.to_dict())
            _dict['_links'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ListResult:
        """Create an instance of ListResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ListResult.parse_obj(obj)

        _obj = ListResult.parse_obj({
            "var_self": SelfResourceLink.from_dict(obj.get("_self")) if obj.get("_self") is not None else None,
            "links": [ResourceLink.from_dict(_item) for _item in obj.get("_links")] if obj.get("_links") is not None else None,
            "var_schema": obj.get("_schema"),
            "result_count": obj.get("result_count"),
            "sort_by": obj.get("sort_by"),
            "sort_ascending": obj.get("sort_ascending"),
            "cursor": obj.get("cursor")
        })
        return _obj


