# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist, constr
from openapi.models.resource_link import ResourceLink
from openapi.models.self_resource_link import SelfResourceLink

class ManagedResource(BaseModel):
    """
    ManagedResource
    """
    var_self: Optional[SelfResourceLink] = Field(None, alias="_self")
    links: Optional[conlist(ResourceLink)] = Field(None, alias="_links", description="The server will populate this field when returing the resource. Ignored on PUT and POST.")
    var_schema: Optional[StrictStr] = Field(None, alias="_schema", description="Schema for this resource")
    revision: Optional[StrictInt] = Field(None, alias="_revision", description="The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.")
    resource_type: Optional[StrictStr] = Field(None, description="The type of this resource.")
    create_user: Optional[StrictStr] = Field(None, alias="_create_user", description="ID of the user who created this resource")
    create_time: Optional[StrictInt] = Field(None, alias="_create_time", description="Timestamp in milliseconds since epoch")
    last_modified_user: Optional[StrictStr] = Field(None, alias="_last_modified_user", description="ID of the user who last modified this resource")
    last_modified_time: Optional[StrictInt] = Field(None, alias="_last_modified_time", description="Timestamp in milliseconds since epoch")
    system_owned: Optional[StrictBool] = Field(None, alias="_system_owned", description="Indicates system owned resource")
    protection: Optional[StrictStr] = Field(None, alias="_protection", description="Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. ")
    id: Optional[StrictStr] = Field(None, description="Unique identifier of this resource")
    display_name: Optional[constr(strict=True, max_length=255)] = Field(None, description="Defaults to ID if not set")
    description: Optional[constr(strict=True, max_length=1024)] = Field(None, description="Description of this resource")
    path: Optional[StrictStr] = Field(None, description="Absolute path of this object")
    relative_path: Optional[StrictStr] = Field(None, description="Path relative from its parent")
    parent_path: Optional[StrictStr] = Field(None, description="Path of its parent")
    __properties = ["_self", "_links", "_schema", "_revision", "resource_type", "_create_user", "_create_time", "_last_modified_user", "_last_modified_time", "_system_owned", "_protection", "id", "display_name", "description", "path", "relative_path", "parent_path"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ManagedResource:
        """Create an instance of ManagedResource from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of var_self
        if self.var_self:
            _dict['_self'] = self.var_self.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in links (list)
        _items = []
        if self.links:
            for _item in self.links:
                if _item:
                    _items.append(_item.to_dict())
            _dict['_links'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ManagedResource:
        """Create an instance of ManagedResource from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ManagedResource.parse_obj(obj)

        _obj = ManagedResource.parse_obj({
            "var_self": SelfResourceLink.from_dict(obj.get("_self")) if obj.get("_self") is not None else None,
            "links": [ResourceLink.from_dict(_item) for _item in obj.get("_links")] if obj.get("_links") is not None else None,
            "var_schema": obj.get("_schema"),
            "revision": obj.get("_revision"),
            "resource_type": obj.get("resource_type"),
            "create_user": obj.get("_create_user"),
            "create_time": obj.get("_create_time"),
            "last_modified_user": obj.get("_last_modified_user"),
            "last_modified_time": obj.get("_last_modified_time"),
            "system_owned": obj.get("_system_owned"),
            "protection": obj.get("_protection"),
            "id": obj.get("id"),
            "display_name": obj.get("display_name"),
            "description": obj.get("description"),
            "path": obj.get("path"),
            "relative_path": obj.get("relative_path"),
            "parent_path": obj.get("parent_path")
        })
        return _obj


