# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import Field, StrictInt, StrictStr, validator
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement
from openapi.models.series import Series

class NameResolutionReport(BaseAnomalyEventDetail):
    """
    NameResolutionReport
    """
    response_count: Optional[Series] = None
    vm_responded_count: Optional[Series] = None
    protocol: Optional[StrictStr] = Field(None, description="direction of traffic")
    number_of_requests_received: Optional[StrictInt] = Field(None, description="Number of requests received by the responder today")
    number_of_responses_sent: Optional[StrictInt] = Field(None, description="Number of requests responded by the responder today")
    number_of_vms_responded: Optional[StrictInt] = Field(None, description="Number of vms that were responded today")
    number_of_new_vms_responded: Optional[StrictInt] = Field(None, description="Number of new vms that were responded today compared to the baseline")
    __properties = ["report_type", "viz_filter_elements", "response_count", "vm_responded_count", "protocol", "number_of_requests_received", "number_of_responses_sent", "number_of_vms_responded", "number_of_new_vms_responded"]

    @validator('protocol')
    def protocol_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('LLMNR', 'NBTNS'):
            raise ValueError("must be one of enum values ('LLMNR', 'NBTNS')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> NameResolutionReport:
        """Create an instance of NameResolutionReport from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of response_count
        if self.response_count:
            _dict['response_count'] = self.response_count.to_dict()
        # override the default output from pydantic by calling `to_dict()` of vm_responded_count
        if self.vm_responded_count:
            _dict['vm_responded_count'] = self.vm_responded_count.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> NameResolutionReport:
        """Create an instance of NameResolutionReport from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NameResolutionReport.parse_obj(obj)

        _obj = NameResolutionReport.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "response_count": Series.from_dict(obj.get("response_count")) if obj.get("response_count") is not None else None,
            "vm_responded_count": Series.from_dict(obj.get("vm_responded_count")) if obj.get("vm_responded_count") is not None else None,
            "protocol": obj.get("protocol"),
            "number_of_requests_received": obj.get("number_of_requests_received"),
            "number_of_responses_sent": obj.get("number_of_responses_sent"),
            "number_of_vms_responded": obj.get("number_of_vms_responded"),
            "number_of_new_vms_responded": obj.get("number_of_new_vms_responded")
        })
        return _obj


