# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist

class NormalizedRecommendationRule(BaseModel):
    """
    The detailed information of a normalized rule  # noqa: E501
    """
    src_vm_ids: Optional[conlist(StrictStr)] = Field(None, description="all vm/bm ids from the src groups if exists")
    dst_vm_ids: Optional[conlist(StrictStr)] = Field(None, description="all vm/bm ids from the dst groups if exists")
    src_ips: Optional[conlist(StrictStr)] = Field(None, description="all Ips/CIDRs from the src groups if exists")
    dst_ips: Optional[conlist(StrictStr)] = Field(None, description="all Ips/CIDRs from the dst groups if exists")
    context_src_vm_ids: Optional[conlist(StrictStr)] = Field(None, description="the overlap vm/bm ids between the src groups and applied-to groups if exists")
    context_dst_vm_ids: Optional[conlist(StrictStr)] = Field(None, description="the overlap vm/bm ids between the dst groups and applied-to groups if exists")
    context_src_ips: Optional[conlist(StrictStr)] = Field(None, description="the overlap Ips/CIDRs between the src groups and applied-to groups if exists")
    context_dst_ips: Optional[conlist(StrictStr)] = Field(None, description="the overlap Ips/CIDRs between the dst groups and applied-to groups if exists")
    dst_ports: Optional[conlist(StrictStr)] = Field(None, description="The destination port(s) of the selected rule")
    protocols: Optional[conlist(StrictStr)] = Field(None, description="The protocol(s) of the selected rule")
    app_ids: Optional[conlist(StrictStr)] = Field(None, description="The appId(s) of the selected rule")
    __properties = ["src_vm_ids", "dst_vm_ids", "src_ips", "dst_ips", "context_src_vm_ids", "context_dst_vm_ids", "context_src_ips", "context_dst_ips", "dst_ports", "protocols", "app_ids"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> NormalizedRecommendationRule:
        """Create an instance of NormalizedRecommendationRule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> NormalizedRecommendationRule:
        """Create an instance of NormalizedRecommendationRule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NormalizedRecommendationRule.parse_obj(obj)

        _obj = NormalizedRecommendationRule.parse_obj({
            "src_vm_ids": obj.get("src_vm_ids"),
            "dst_vm_ids": obj.get("dst_vm_ids"),
            "src_ips": obj.get("src_ips"),
            "dst_ips": obj.get("dst_ips"),
            "context_src_vm_ids": obj.get("context_src_vm_ids"),
            "context_dst_vm_ids": obj.get("context_dst_vm_ids"),
            "context_src_ips": obj.get("context_src_ips"),
            "context_dst_ips": obj.get("context_dst_ips"),
            "dst_ports": obj.get("dst_ports"),
            "protocols": obj.get("protocols"),
            "app_ids": obj.get("app_ids")
        })
        return _obj


