# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, StrictInt, StrictStr, conlist
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement

class PortProfilerEventDetail(BaseAnomalyEventDetail):
    """
    PortProfilerEventDetail
    """
    anomaly: Optional[StrictStr] = Field(None, description="The port number that was found to be anomalous.")
    baseline_items: Optional[conlist(StrictStr)] = Field(None, description="List of ports that are part of the baseline.")
    profile_creation: Optional[StrictInt] = Field(None, description="Time when the baseline was established")
    __properties = ["report_type", "viz_filter_elements", "anomaly", "baseline_items", "profile_creation"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PortProfilerEventDetail:
        """Create an instance of PortProfilerEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PortProfilerEventDetail:
        """Create an instance of PortProfilerEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PortProfilerEventDetail.parse_obj(obj)

        _obj = PortProfilerEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "anomaly": obj.get("anomaly"),
            "baseline_items": obj.get("baseline_items"),
            "profile_creation": obj.get("profile_creation")
        })
        return _obj


