# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, StrictInt, conlist
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement
from openapi.models.scanned_vm_details import ScannedVmDetails
from openapi.models.series import Series

class PortScanVerticalEventDetail(BaseAnomalyEventDetail):
    """
    PortScanVerticalEventDetail
    """
    port_count: Optional[Series] = None
    scanner_info: Optional[conlist(ScannedVmDetails)] = Field(None, description="List of source VMs by scanned destination ports.")
    total_ports: Optional[StrictInt] = Field(None, description="Total number of ports scanned today")
    total_unique_ports: Optional[StrictInt] = Field(None, description="Total number of unique ports scanned today compared to baseline")
    unique_ports_percent: Optional[StrictInt] = Field(None, description="Unique ports scanned today in percentage")
    __properties = ["report_type", "viz_filter_elements", "port_count", "scanner_info", "total_ports", "total_unique_ports", "unique_ports_percent"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PortScanVerticalEventDetail:
        """Create an instance of PortScanVerticalEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of port_count
        if self.port_count:
            _dict['port_count'] = self.port_count.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in scanner_info (list)
        _items = []
        if self.scanner_info:
            for _item in self.scanner_info:
                if _item:
                    _items.append(_item.to_dict())
            _dict['scanner_info'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PortScanVerticalEventDetail:
        """Create an instance of PortScanVerticalEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PortScanVerticalEventDetail.parse_obj(obj)

        _obj = PortScanVerticalEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "port_count": Series.from_dict(obj.get("port_count")) if obj.get("port_count") is not None else None,
            "scanner_info": [ScannedVmDetails.from_dict(_item) for _item in obj.get("scanner_info")] if obj.get("scanner_info") is not None else None,
            "total_ports": obj.get("total_ports"),
            "total_unique_ports": obj.get("total_unique_ports"),
            "unique_ports_percent": obj.get("unique_ports_percent")
        })
        return _obj


