# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from openapi.models.scanned_vm_details import ScannedVmDetails

class PortSweepEvidence(BaseModel):
    """
    Describes the source which started a scan and the entities affected by it.  # noqa: E501
    """
    scanner_ip: Optional[StrictStr] = Field(None, description="IP Address of the scanner")
    scanner_vm_id: Optional[StrictStr] = Field(None, description="ID associated with the scanner VM. This will be empty in case of an external scanner")
    scanned_vms: Optional[conlist(ScannedVmDetails)] = Field(None, description="Details about the VMs affected by the scan.")
    __properties = ["scanner_ip", "scanner_vm_id", "scanned_vms"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PortSweepEvidence:
        """Create an instance of PortSweepEvidence from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in scanned_vms (list)
        _items = []
        if self.scanned_vms:
            for _item in self.scanned_vms:
                if _item:
                    _items.append(_item.to_dict())
            _dict['scanned_vms'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PortSweepEvidence:
        """Create an instance of PortSweepEvidence from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PortSweepEvidence.parse_obj(obj)

        _obj = PortSweepEvidence.parse_obj({
            "scanner_ip": obj.get("scanner_ip"),
            "scanner_vm_id": obj.get("scanner_vm_id"),
            "scanned_vms": [ScannedVmDetails.from_dict(_item) for _item in obj.get("scanned_vms")] if obj.get("scanned_vms") is not None else None
        })
        return _obj


