# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class RemoteServiceEdge(BaseModel):
    """
    Describes the connection between two nodes(VM, BareMetal, etc..).  # noqa: E501
    """
    id: Optional[StrictStr] = Field(None, description="ID of this edge.")
    l7_app_name: Optional[StrictStr] = Field(None, description="L7 app name for this connection.")
    port: Optional[StrictStr] = Field(None, description="Destination port number used for this connection.")
    protocol: Optional[StrictStr] = Field(None, description="Protocol used for this connection.")
    user: Optional[StrictStr] = Field(None, description="User id for this connection.")
    is_suspicious: Optional[StrictBool] = Field(None, description="Indicates whether this connection is usual or suspicious.")
    start_time: Optional[StrictInt] = Field(None, description="Time when the flow is started.")
    end_time: Optional[StrictInt] = Field(None, description="Time when the flow is ended.")
    from_node: Optional[StrictStr] = Field(None, description="ID of the 'from' node where the connection started.")
    to_node: Optional[StrictStr] = Field(None, description="ID of the 'to' node where the connection ended.")
    __properties = ["id", "l7_app_name", "port", "protocol", "user", "is_suspicious", "start_time", "end_time", "from_node", "to_node"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RemoteServiceEdge:
        """Create an instance of RemoteServiceEdge from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RemoteServiceEdge:
        """Create an instance of RemoteServiceEdge from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RemoteServiceEdge.parse_obj(obj)

        _obj = RemoteServiceEdge.parse_obj({
            "id": obj.get("id"),
            "l7_app_name": obj.get("l7_app_name"),
            "port": obj.get("port"),
            "protocol": obj.get("protocol"),
            "user": obj.get("user"),
            "is_suspicious": obj.get("is_suspicious"),
            "start_time": obj.get("start_time"),
            "end_time": obj.get("end_time"),
            "from_node": obj.get("from_node"),
            "to_node": obj.get("to_node")
        })
        return _obj


