# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist
from openapi.models.remote_service_node_metric import RemoteServiceNodeMetric

class RemoteServiceNode(BaseModel):
    """
    Describes the node with key metrics and whether this node seen any suspicious acitivity or not.  # noqa: E501
    """
    id: Optional[StrictStr] = Field(None, description="ID of this node.")
    is_suspicious: Optional[StrictBool] = Field(None, description="Flag indicates that this node is suspicious or not.")
    metrics: Optional[conlist(RemoteServiceNodeMetric)] = Field(None, description="List of metrics as a key value pair.")
    __properties = ["id", "is_suspicious", "metrics"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RemoteServiceNode:
        """Create an instance of RemoteServiceNode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in metrics (list)
        _items = []
        if self.metrics:
            for _item in self.metrics:
                if _item:
                    _items.append(_item.to_dict())
            _dict['metrics'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RemoteServiceNode:
        """Create an instance of RemoteServiceNode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RemoteServiceNode.parse_obj(obj)

        _obj = RemoteServiceNode.parse_obj({
            "id": obj.get("id"),
            "is_suspicious": obj.get("is_suspicious"),
            "metrics": [RemoteServiceNodeMetric.from_dict(_item) for _item in obj.get("metrics")] if obj.get("metrics") is not None else None
        })
        return _obj


