# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class RemoteServiceNodeMetric(BaseModel):
    """
    Key value pair holds graph node metric info.  # noqa: E501
    """
    key: Optional[StrictStr] = Field(None, description="A metric name as a enum")
    value: Optional[StrictInt] = Field(None, description="Value of the metric.")
    __properties = ["key", "value"]

    @validator('key')
    def key_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('TODAY_DESTINATION_PORTS', 'MEAN_DESTINATION_PORTS', 'TODAY_PROTOCOLS', 'MEAN_PROTOCOLS', 'TODAY_L7_APPS', 'MEAN_L7_APPS', 'TODAY_CONNECTIONS', 'MEAN_CONNECTIONS', 'TODAY_PROCESS', 'MEAN_PROCESS'):
            raise ValueError("must be one of enum values ('TODAY_DESTINATION_PORTS', 'MEAN_DESTINATION_PORTS', 'TODAY_PROTOCOLS', 'MEAN_PROTOCOLS', 'TODAY_L7_APPS', 'MEAN_L7_APPS', 'TODAY_CONNECTIONS', 'MEAN_CONNECTIONS', 'TODAY_PROCESS', 'MEAN_PROCESS')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RemoteServiceNodeMetric:
        """Create an instance of RemoteServiceNodeMetric from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RemoteServiceNodeMetric:
        """Create an instance of RemoteServiceNodeMetric from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RemoteServiceNodeMetric.parse_obj(obj)

        _obj = RemoteServiceNodeMetric.parse_obj({
            "key": obj.get("key"),
            "value": obj.get("value")
        })
        return _obj


