# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, StrictBool, StrictStr, conlist
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement
from openapi.models.remote_service_edge import RemoteServiceEdge
from openapi.models.remote_service_node import RemoteServiceNode

class RemoteServicesEventDetail(BaseAnomalyEventDetail):
    """
    RemoteServicesEventDetail
    """
    root_entity_node_id: Optional[StrictStr] = Field(None, description="ID of the root node from where the connection begin.")
    is_from_public: Optional[StrictBool] = Field(None, description="Tells whether the attack came from public network.")
    graph_edges: Optional[conlist(RemoteServiceEdge)] = Field(None, description="List of graph edges.")
    graph_nodes: Optional[conlist(RemoteServiceNode)] = Field(None, description="List of graph nodes.")
    __properties = ["report_type", "viz_filter_elements", "root_entity_node_id", "is_from_public", "graph_edges", "graph_nodes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RemoteServicesEventDetail:
        """Create an instance of RemoteServicesEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in graph_edges (list)
        _items = []
        if self.graph_edges:
            for _item in self.graph_edges:
                if _item:
                    _items.append(_item.to_dict())
            _dict['graph_edges'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in graph_nodes (list)
        _items = []
        if self.graph_nodes:
            for _item in self.graph_nodes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['graph_nodes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RemoteServicesEventDetail:
        """Create an instance of RemoteServicesEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RemoteServicesEventDetail.parse_obj(obj)

        _obj = RemoteServicesEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "root_entity_node_id": obj.get("root_entity_node_id"),
            "is_from_public": obj.get("is_from_public"),
            "graph_edges": [RemoteServiceEdge.from_dict(_item) for _item in obj.get("graph_edges")] if obj.get("graph_edges") is not None else None,
            "graph_nodes": [RemoteServiceNode.from_dict(_item) for _item in obj.get("graph_nodes")] if obj.get("graph_nodes") is not None else None
        })
        return _obj


