# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr, conlist
from openapi.models.filter_element import FilterElement
from openapi.models.sort_by import SortBy

class RequestParameters(BaseModel):
    """
    The set of parameters for returning a list of records.  # noqa: E501
    """
    filter_elements: Optional[conlist(FilterElement)] = Field(None, description="A list of filter elements.")
    cursor: Optional[StrictStr] = Field(None, description="A cursor to keep track of pages returned by the backend (a page number)")
    page_size: Optional[StrictInt] = Field(100, description="Number of records to be returned in the API request")
    sort_ascending: Optional[StrictBool] = Field(False, description="True, if the list of records returned need to be sorted in ascending order, false otherwise.")
    sort_by: Optional[SortBy] = None
    __properties = ["filter_elements", "cursor", "page_size", "sort_ascending", "sort_by"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RequestParameters:
        """Create an instance of RequestParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in filter_elements (list)
        _items = []
        if self.filter_elements:
            for _item in self.filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of sort_by
        if self.sort_by:
            _dict['sort_by'] = self.sort_by.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RequestParameters:
        """Create an instance of RequestParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RequestParameters.parse_obj(obj)

        _obj = RequestParameters.parse_obj({
            "filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("filter_elements")] if obj.get("filter_elements") is not None else None,
            "cursor": obj.get("cursor"),
            "page_size": obj.get("page_size") if obj.get("page_size") is not None else 100,
            "sort_ascending": obj.get("sort_ascending") if obj.get("sort_ascending") is not None else False,
            "sort_by": SortBy.from_dict(obj.get("sort_by")) if obj.get("sort_by") is not None else None
        })
        return _obj


