# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist
from openapi.models.port_protocol import PortProtocol

class ScannedVmDetails(BaseModel):
    """
    Details regarding the Virtual Machines affected by a port scan  # noqa: E501
    """
    vm_id: Optional[StrictStr] = Field(None, description="ID associated with the Virtual Machine.")
    ports: Optional[conlist(StrictInt)] = Field(None, description="List of ports scanned")
    port_protocols: Optional[conlist(PortProtocol)] = Field(None, description="List of Port and Protocol involved in the port scan")
    __properties = ["vm_id", "ports", "port_protocols"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ScannedVmDetails:
        """Create an instance of ScannedVmDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in port_protocols (list)
        _items = []
        if self.port_protocols:
            for _item in self.port_protocols:
                if _item:
                    _items.append(_item.to_dict())
            _dict['port_protocols'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ScannedVmDetails:
        """Create an instance of ScannedVmDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ScannedVmDetails.parse_obj(obj)

        _obj = ScannedVmDetails.parse_obj({
            "vm_id": obj.get("vm_id"),
            "ports": obj.get("ports"),
            "port_protocols": [PortProtocol.from_dict(_item) for _item in obj.get("port_protocols")] if obj.get("port_protocols") is not None else None
        })
        return _obj


