# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, StrictStr, conlist, validator
from openapi.models.filter_element import FilterElement

class SimpleFilter(FilterElement):
    """
    Simple key-value object for filter. Key is a string value is an array of strings. e.g. Can be used to answer queries   such as vm.name CONTAINS [\"vm1\" or \"vm2\"].  # noqa: E501
    """
    key: StrictStr = Field(..., description="The key is a string.")
    value: conlist(StrictStr) = Field(..., description="The values to search for.")
    criteria: Optional[StrictStr] = Field('EQUALS', description="criteria for controlling how the value is matched. CONTAINS matches for any value in the value array. |")
    __properties = ["filter_type", "key", "value", "criteria"]

    @validator('criteria')
    def criteria_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('EQUALS', 'EXCLUDES', 'CONTAINS', 'STARTS_WITH'):
            raise ValueError("must be one of enum values ('EQUALS', 'EXCLUDES', 'CONTAINS', 'STARTS_WITH')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SimpleFilter:
        """Create an instance of SimpleFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SimpleFilter:
        """Create an instance of SimpleFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SimpleFilter.parse_obj(obj)

        _obj = SimpleFilter.parse_obj({
            "filter_type": obj.get("filter_type") if obj.get("filter_type") is not None else 'SIMPLE',
            "key": obj.get("key"),
            "value": obj.get("value"),
            "criteria": obj.get("criteria") if obj.get("criteria") is not None else 'EQUALS'
        })
        return _obj


