# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, StrictStr, conlist, validator
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement
from openapi.models.series import Series
from openapi.models.traffic_drop_event_detail_marker import TrafficDropEventDetailMarker

class TrafficDropEventDetail(BaseAnomalyEventDetail):
    """
    TrafficDropEventDetail
    """
    drop_count: Optional[Series] = None
    allow_count: Optional[Series] = None
    new_ports: Optional[conlist(StrictStr)] = Field(None, description="New traffic being dropped")
    marker: Optional[conlist(TrafficDropEventDetailMarker)] = Field(None, description="Markers on the event detail report.")
    direction: Optional[StrictStr] = Field(None, description="direction of traffic")
    __properties = ["report_type", "viz_filter_elements", "drop_count", "allow_count", "new_ports", "marker", "direction"]

    @validator('direction')
    def direction_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('INCOMING', 'OUTGOING'):
            raise ValueError("must be one of enum values ('INCOMING', 'OUTGOING')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TrafficDropEventDetail:
        """Create an instance of TrafficDropEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of drop_count
        if self.drop_count:
            _dict['drop_count'] = self.drop_count.to_dict()
        # override the default output from pydantic by calling `to_dict()` of allow_count
        if self.allow_count:
            _dict['allow_count'] = self.allow_count.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in marker (list)
        _items = []
        if self.marker:
            for _item in self.marker:
                if _item:
                    _items.append(_item.to_dict())
            _dict['marker'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TrafficDropEventDetail:
        """Create an instance of TrafficDropEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TrafficDropEventDetail.parse_obj(obj)

        _obj = TrafficDropEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "drop_count": Series.from_dict(obj.get("drop_count")) if obj.get("drop_count") is not None else None,
            "allow_count": Series.from_dict(obj.get("allow_count")) if obj.get("allow_count") is not None else None,
            "new_ports": obj.get("new_ports"),
            "marker": [TrafficDropEventDetailMarker.from_dict(_item) for _item in obj.get("marker")] if obj.get("marker") is not None else None,
            "direction": obj.get("direction")
        })
        return _obj


