# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator

class TrafficDropEventDetailMarker(BaseModel):
    """
    Event representing a configuration change  # noqa: E501
    """
    timestamp: Optional[StrictInt] = Field(None, description="Indicates the timestamp of the config change event")
    config_entity_id: Optional[StrictStr] = Field(None, description="policy path or mp uuid of the entity")
    config_entity_display_name: Optional[StrictStr] = Field(None, description="display_name of the entity")
    config_change_type: Optional[StrictStr] = Field(None, description="Config change type")
    details: Optional[StrictStr] = Field(None, description="Details on config change event")
    __properties = ["timestamp", "config_entity_id", "config_entity_display_name", "config_change_type", "details"]

    @validator('config_change_type')
    def config_change_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('RULE_CHANGE', 'GROUP_CHANGE'):
            raise ValueError("must be one of enum values ('RULE_CHANGE', 'GROUP_CHANGE')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TrafficDropEventDetailMarker:
        """Create an instance of TrafficDropEventDetailMarker from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TrafficDropEventDetailMarker:
        """Create an instance of TrafficDropEventDetailMarker from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TrafficDropEventDetailMarker.parse_obj(obj)

        _obj = TrafficDropEventDetailMarker.parse_obj({
            "timestamp": obj.get("timestamp"),
            "config_entity_id": obj.get("config_entity_id"),
            "config_entity_display_name": obj.get("config_entity_display_name"),
            "config_change_type": obj.get("config_change_type"),
            "details": obj.get("details")
        })
        return _obj


