# coding: utf-8

"""
    NTA / Anomaly APIs

    NTA / Anomaly APIs

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import Field, StrictInt, StrictStr, conlist, validator
from openapi.models.base_anomaly_event_detail import BaseAnomalyEventDetail
from openapi.models.filter_element import FilterElement
from openapi.models.float_interval import FloatInterval
from openapi.models.time_data import TimeData

class UpDownLoaderTimeSeriesEventDetail(BaseAnomalyEventDetail):
    """
    UpDownLoaderTimeSeriesEventDetail
    """
    time_series: Optional[conlist(TimeData, max_items=2000)] = Field(None, description="observed data points")
    prediction: Optional[conlist(TimeData, max_items=1000)] = Field(None, description="predicted data points")
    metric: Optional[StrictStr] = Field(None, description="modeled metrics type (upload/download/pcr)")
    confidence_interval: Optional[conlist(FloatInterval, max_items=1000)] = Field(None, description="Represents list of the confidence upper/lower bound associated with each past measurement and prediction Any observation that exceeds this range is considered as anomalous")
    service: Optional[StrictStr] = Field(None, description="L7 protocol")
    model_ts: Optional[StrictInt] = Field(None, description="Timestamp in milliseconds since epoch")
    alert_start_time: Optional[StrictInt] = Field(None, description="Timestamp in milliseconds since epoch")
    alert_end_time: Optional[StrictInt] = Field(None, description="Timestamp in milliseconds since epoch")
    __properties = ["report_type", "viz_filter_elements", "time_series", "prediction", "metric", "confidence_interval", "service", "model_ts", "alert_start_time", "alert_end_time"]

    @validator('metric')
    def metric_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('UPLOAD', 'DOWNLOAD', 'PCR', 'INBOUND', 'OUTBOUND'):
            raise ValueError("must be one of enum values ('UPLOAD', 'DOWNLOAD', 'PCR', 'INBOUND', 'OUTBOUND')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpDownLoaderTimeSeriesEventDetail:
        """Create an instance of UpDownLoaderTimeSeriesEventDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in viz_filter_elements (list)
        _items = []
        if self.viz_filter_elements:
            for _item in self.viz_filter_elements:
                if _item:
                    _items.append(_item.to_dict())
            _dict['viz_filter_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in time_series (list)
        _items = []
        if self.time_series:
            for _item in self.time_series:
                if _item:
                    _items.append(_item.to_dict())
            _dict['time_series'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in prediction (list)
        _items = []
        if self.prediction:
            for _item in self.prediction:
                if _item:
                    _items.append(_item.to_dict())
            _dict['prediction'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in confidence_interval (list)
        _items = []
        if self.confidence_interval:
            for _item in self.confidence_interval:
                if _item:
                    _items.append(_item.to_dict())
            _dict['confidence_interval'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpDownLoaderTimeSeriesEventDetail:
        """Create an instance of UpDownLoaderTimeSeriesEventDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpDownLoaderTimeSeriesEventDetail.parse_obj(obj)

        _obj = UpDownLoaderTimeSeriesEventDetail.parse_obj({
            "report_type": obj.get("report_type"),
            "viz_filter_elements": [FilterElement.from_dict(_item) for _item in obj.get("viz_filter_elements")] if obj.get("viz_filter_elements") is not None else None,
            "time_series": [TimeData.from_dict(_item) for _item in obj.get("time_series")] if obj.get("time_series") is not None else None,
            "prediction": [TimeData.from_dict(_item) for _item in obj.get("prediction")] if obj.get("prediction") is not None else None,
            "metric": obj.get("metric"),
            "confidence_interval": [FloatInterval.from_dict(_item) for _item in obj.get("confidence_interval")] if obj.get("confidence_interval") is not None else None,
            "service": obj.get("service"),
            "model_ts": obj.get("model_ts"),
            "alert_start_time": obj.get("alert_start_time"),
            "alert_end_time": obj.get("alert_end_time")
        })
        return _obj


